Bug 10860 - On-site checkouts (was In-House Use)
Summary: On-site checkouts (was In-House Use)
Status: CLOSED FIXED
Alias: None
Product: Koha
Classification: Unclassified
Component: Circulation (show other bugs)
Version: master
Hardware: All All
: P5 - low new feature (vote)
Assignee: Jonathan Druart
QA Contact: Testopia
URL:
Keywords: rel_3_18_candidate
Depends on:
Blocks: 11201 13179 13183 13184 13234 13255 14470 15569 16478
  Show dependency treegraph
 
Reported: 2013-09-10 11:57 UTC by Jonathan Druart
Modified: 2016-12-05 21:23 UTC (History)
15 users (show)

See Also:
Change sponsored?: ---
Patch complexity: Large patch
Who signed the patch off:
Text to go in the release notes:
Version(s) released in:


Attachments
Bug 10860: In-House Use (56.65 KB, patch)
2013-09-10 14:05 UTC, Jonathan Druart
Details | Diff | Splinter Review
quick view: checkout list (58.17 KB, image/png)
2013-09-10 14:11 UTC, Jonathan Druart
Details
quick view: circulation history (51.54 KB, image/png)
2013-09-10 14:12 UTC, Jonathan Druart
Details
Bug 10860: In-House Use (50.57 KB, patch)
2013-09-18 12:17 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 10860: In-House Use (50.82 KB, patch)
2013-09-30 08:09 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 10860: In-House Use (50.85 KB, patch)
2013-10-28 09:00 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 10860: In-House Use (50.23 KB, patch)
2014-03-11 11:31 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 10860: In-House Use (50.23 KB, patch)
2014-03-11 14:44 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 10860: In-House Use (50.17 KB, patch)
2014-03-11 16:03 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 10860: In-House Use (50.08 KB, patch)
2014-03-12 14:54 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 10860: In-House Use (50.08 KB, patch)
2014-03-12 15:28 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 10860: In-House use should not be renewed (2.50 KB, patch)
2014-03-12 15:28 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 10860: In-House Use (50.31 KB, patch)
2014-09-05 11:07 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 10860: In-House Use (49.64 KB, patch)
2014-09-10 14:36 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 10860: In-House Use (47.00 KB, patch)
2014-09-12 07:47 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 10860: In-House Use (47.06 KB, patch)
2014-09-17 09:56 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 10860: wording: "in-house use" => "on-site checkout" (28.96 KB, patch)
2014-09-17 09:57 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 10860: In-House Use (47.17 KB, patch)
2014-10-10 21:03 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 10860: wording: "in-house use" => "on-site checkout" (29.11 KB, patch)
2014-10-10 21:04 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 10860: In-House Use (47.22 KB, patch)
2014-10-10 21:37 UTC, Chris Cormack
Details | Diff | Splinter Review
Bug 10860: wording: "in-house use" => "on-site checkout" (29.17 KB, patch)
2014-10-10 21:39 UTC, Chris Cormack
Details | Diff | Splinter Review
Bug 10860: In-House Use (46.54 KB, patch)
2014-10-22 15:17 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 10860 - Change "in-house use" to "on-site checkout" (27.43 KB, patch)
2014-10-22 15:17 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 10860 [QA Followup] - Fix misc issues (6.21 KB, patch)
2014-10-22 15:17 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 10860: Follow-up - staff reading record (2.31 KB, patch)
2014-10-29 23:51 UTC, Katrin Fischer
Details | Diff | Splinter Review
Bug 10860: In-House Use (41.59 KB, patch)
2014-10-30 15:58 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 10860: In-House Use (41.59 KB, patch)
2014-10-30 16:02 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 10860 - Change "in-house use" to "on-site checkout" (25.80 KB, patch)
2014-10-30 16:03 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 10860 [QA Followup] - Fix misc issues (6.21 KB, patch)
2014-10-30 16:03 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 10860: Follow-up - staff reading record (2.35 KB, patch)
2014-10-30 16:03 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 10860 [QA Followup] - Rename system preferences (7.99 KB, patch)
2014-10-30 16:03 UTC, Kyle M Hall
Details | Diff | Splinter Review
[PASSED QA] Bug 10860 [QA Followup] - Rename system preferences (8.15 KB, patch)
2014-10-30 19:37 UTC, Katrin Fischer
Details | Diff | Splinter Review
Bug 10860: Follow-up - fix some template variable issues (4.05 KB, patch)
2014-10-30 19:37 UTC, Katrin Fischer
Details | Diff | Splinter Review
Bug 10860: In-House Use (41.59 KB, patch)
2014-10-31 10:22 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 10860 - Change "in-house use" to "on-site checkout" (25.80 KB, patch)
2014-10-31 10:22 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 10860 [QA Followup] - Fix misc issues (6.21 KB, patch)
2014-10-31 10:22 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 10860: Follow-up - staff reading record (2.35 KB, patch)
2014-10-31 10:22 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 10860 [QA Followup] - Rename system preferences (8.05 KB, patch)
2014-10-31 10:22 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 10860: Follow-up - fix some template variable issues (4.08 KB, patch)
2014-10-31 10:23 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 10860 [QA Followup] - Use Koha.Preference (2.35 KB, patch)
2014-10-31 10:23 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 10860: In-House Use (41.58 KB, patch)
2014-10-31 19:56 UTC, Katrin Fischer
Details | Diff | Splinter Review
Bug 10860 - Change "in-house use" to "on-site checkout" (25.78 KB, patch)
2014-10-31 19:57 UTC, Katrin Fischer
Details | Diff | Splinter Review
Bug 10860 [QA Followup] - Fix misc issues (6.24 KB, patch)
2014-10-31 19:57 UTC, Katrin Fischer
Details | Diff | Splinter Review
Bug 10860: Follow-up - staff reading record (2.36 KB, patch)
2014-10-31 19:57 UTC, Katrin Fischer
Details | Diff | Splinter Review
Bug 10860 [QA Followup] - Rename system preferences (8.14 KB, patch)
2014-10-31 19:57 UTC, Katrin Fischer
Details | Diff | Splinter Review
Bug 10860: Follow-up - fix some template variable issues (4.10 KB, patch)
2014-10-31 19:57 UTC, Katrin Fischer
Details | Diff | Splinter Review
[PASSED QA] Bug 10860 [QA Followup] - Use Koha.Preference (2.42 KB, patch)
2014-10-31 19:57 UTC, Katrin Fischer
Details | Diff | Splinter Review
Bug 10860: Update DBIx (2.44 KB, patch)
2014-11-03 14:37 UTC, Tomás Cohen Arazi
Details | Diff | Splinter Review
Bug 10860: (RM followup) checkout-related sysprefs belong to the checkouts section (2.35 KB, patch)
2014-11-03 14:55 UTC, Tomás Cohen Arazi
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Jonathan Druart 2013-09-10 11:57:21 UTC
This feature implements the In-House Use feature for Koha.
Comment 1 Katrin Fischer 2013-09-10 12:01:19 UTC
We currently use statistical patrons for recording in-house use - can you describe a bit more how the new feature will work?
Comment 2 Jared Camins-Esakov 2013-09-10 12:02:07 UTC
Doesn't Koha already have in-house use tracking with both statistical patrons and RecordLocalUseOnReturn?
Comment 3 Jonathan Druart 2013-09-10 13:57:38 UTC
The feature will allow to distinguish a checkout to an in-house use (visually: tabs in the circulation history, line "(In-house use)" in the checkout list at the OPAC and staff interfaces, etc.).

It will be possible to do a checkout to a debarred patron, which is not possible with the existing feature.

The patch won't delete the RecordLocalUseOnReturn, so the 2 features can cohabit ; if this one wins unanimous support, I will submit a followup in order to migrate data from the existing ones (statistics table), if it is possible.
Comment 4 Katrin Fischer 2013-09-10 13:59:47 UTC
> It will be possible to do a checkout to a debarred patron, which is not
> possible with the existing feature.

Hm, why would you want to check out to a debarred patron? And is it a real checkout? (ends on the patron account - or only for counting?
Is there a special option you have to check?
Comment 5 Jonathan Druart 2013-09-10 14:05:23 UTC
(In reply to Katrin Fischer from comment #4)
> > It will be possible to do a checkout to a debarred patron, which is not
> > possible with the existing feature.
> 
> Hm, why would you want to check out to a debarred patron?

It is not a check out but an in-house use, sorry...

> And is it a real checkout? (ends on the patron account - or only for counting?

Yes, it is a check out, with a new flag in DB.

> Is there a special option you have to check?

A new checkbox will be added on the circulation page.

Patch coming... :)
Comment 6 Jonathan Druart 2013-09-10 14:05:37 UTC Comment hidden (obsolete)
Comment 7 Jonathan Druart 2013-09-10 14:11:39 UTC
Created attachment 20960 [details]
quick view: checkout list
Comment 8 Jonathan Druart 2013-09-10 14:12:10 UTC
Created attachment 20961 [details]
quick view: circulation history
Comment 9 I'm just a bot 2013-09-18 10:47:46 UTC
Applying: Bug 10860: In-House Use
Using index info to reconstruct a base tree...
M	C4/Circulation.pm
M	installer/data/mysql/kohastructure.sql
M	installer/data/mysql/sysprefs.sql
M	installer/data/mysql/updatedatabase.pl
M	koha-tmpl/intranet-tmpl/prog/en/js/datatables.js
M	koha-tmpl/intranet-tmpl/prog/en/modules/admin/preferences/circulation.pref
Falling back to patching base and 3-way merge...
Auto-merging koha-tmpl/intranet-tmpl/prog/en/modules/admin/preferences/circulation.pref
Auto-merging koha-tmpl/intranet-tmpl/prog/en/js/datatables.js
Auto-merging installer/data/mysql/updatedatabase.pl
CONFLICT (content): Merge conflict in installer/data/mysql/updatedatabase.pl
Auto-merging installer/data/mysql/sysprefs.sql
Auto-merging installer/data/mysql/kohastructure.sql
Auto-merging C4/Circulation.pm
Patch failed at 0001 Bug 10860: In-House Use
The copy of the patch that failed is found in:
   /home/christopher/git/koha/.git/rebase-apply/patch
When you have resolved this problem, run "git am --continue".
If you prefer to skip this patch, run "git am --skip" instead.
To restore the original branch and stop patching, run "git am --abort".
Comment 10 Jonathan Druart 2013-09-18 12:17:43 UTC Comment hidden (obsolete)
Comment 11 I'm just a bot 2013-09-29 06:06:48 UTC
Applying: Bug 10860: In-House Use
Using index info to reconstruct a base tree...
M	C4/Circulation.pm
M	C4/Items.pm
M	installer/data/mysql/sysprefs.sql
M	installer/data/mysql/updatedatabase.pl
M	koha-tmpl/intranet-tmpl/prog/en/css/staff-global.css
M	koha-tmpl/intranet-tmpl/prog/en/modules/admin/preferences/circulation.pref
M	koha-tmpl/intranet-tmpl/prog/en/modules/catalogue/detail.tt
M	koha-tmpl/intranet-tmpl/prog/en/modules/circ/circulation.tt
Falling back to patching base and 3-way merge...
Auto-merging koha-tmpl/intranet-tmpl/prog/en/modules/circ/circulation.tt
CONFLICT (content): Merge conflict in koha-tmpl/intranet-tmpl/prog/en/modules/circ/circulation.tt
Auto-merging koha-tmpl/intranet-tmpl/prog/en/modules/catalogue/detail.tt
Auto-merging koha-tmpl/intranet-tmpl/prog/en/modules/admin/preferences/circulation.pref
Auto-merging koha-tmpl/intranet-tmpl/prog/en/css/staff-global.css
Auto-merging installer/data/mysql/updatedatabase.pl
CONFLICT (content): Merge conflict in installer/data/mysql/updatedatabase.pl
Auto-merging installer/data/mysql/sysprefs.sql
Auto-merging C4/Items.pm
Auto-merging C4/Circulation.pm
Patch failed at 0001 Bug 10860: In-House Use
The copy of the patch that failed is found in:
   /home/christopher/git/koha/.git/rebase-apply/patch
When you have resolved this problem, run "git am --continue".
If you prefer to skip this patch, run "git am --skip" instead.
To restore the original branch and stop patching, run "git am --abort".
Comment 12 Jonathan Druart 2013-09-30 08:09:44 UTC Comment hidden (obsolete)
Comment 13 I'm just a bot 2013-10-28 06:12:53 UTC
Applying: Bug 10860: In-House Use
Using index info to reconstruct a base tree...
M	C4/Circulation.pm
M	C4/Items.pm
M	circ/circulation.pl
M	installer/data/mysql/kohastructure.sql
M	installer/data/mysql/sysprefs.sql
M	installer/data/mysql/updatedatabase.pl
M	koha-tmpl/intranet-tmpl/prog/en/css/staff-global.css
M	koha-tmpl/intranet-tmpl/prog/en/js/datatables.js
M	koha-tmpl/intranet-tmpl/prog/en/js/pages/circulation.js
M	koha-tmpl/intranet-tmpl/prog/en/modules/admin/preferences/circulation.pref
M	koha-tmpl/opac-tmpl/prog/en/includes/item-status.inc
Falling back to patching base and 3-way merge...
Auto-merging koha-tmpl/opac-tmpl/prog/en/includes/item-status.inc
CONFLICT (content): Merge conflict in koha-tmpl/opac-tmpl/prog/en/includes/item-status.inc
Auto-merging koha-tmpl/intranet-tmpl/prog/en/modules/admin/preferences/circulation.pref
Auto-merging koha-tmpl/intranet-tmpl/prog/en/js/pages/circulation.js
Auto-merging koha-tmpl/intranet-tmpl/prog/en/js/datatables.js
Auto-merging koha-tmpl/intranet-tmpl/prog/en/css/staff-global.css
CONFLICT (content): Merge conflict in koha-tmpl/intranet-tmpl/prog/en/css/staff-global.css
Auto-merging installer/data/mysql/updatedatabase.pl
CONFLICT (content): Merge conflict in installer/data/mysql/updatedatabase.pl
Auto-merging installer/data/mysql/sysprefs.sql
Auto-merging installer/data/mysql/kohastructure.sql
Auto-merging circ/circulation.pl
Auto-merging C4/Items.pm
Auto-merging C4/Circulation.pm
Patch failed at 0001 Bug 10860: In-House Use
The copy of the patch that failed is found in:
   /home/christopher/git/koha/.git/rebase-apply/patch
When you have resolved this problem, run "git am --continue".
If you prefer to skip this patch, run "git am --skip" instead.
To restore the original branch and stop patching, run "git am --abort".
Comment 14 Jonathan Druart 2013-10-28 09:00:00 UTC Comment hidden (obsolete)
Comment 15 mathieu saby 2013-11-29 13:09:09 UTC
Hi. I wanted to test, but I've got the following message. Maybe my VM is not clean, or it is something to fix in the patch?

<stdin>:1276: new blank line at EOF.
+
warning: 1 line adds whitespace errors.
Falling back to patching base and 3-way merge...
error: The following untracked working tree files would be overwritten by merge:
	misc/cronjobs/bulk_transferts.pl
Please move or remove them before you can merge.
Aborting


If it needs rebase, could you replace "13.00" by "15.00" in updatedatabase ?

Mathieu
Comment 16 Jonathan Druart 2013-12-02 10:52:59 UTC
(In reply to mathieu saby from comment #15)
> error: The following untracked working tree files would be overwritten by
> merge:
> 	misc/cronjobs/bulk_transferts.pl

This file does not exist in master. Remove it before applying the patch.
Comment 17 mathieu saby 2013-12-02 12:32:43 UTC
(In reply to Jonathan Druart from comment #16)
> (In reply to mathieu saby from comment #15)
> > error: The following untracked working tree files would be overwritten by
> > merge:
> > 	misc/cronjobs/bulk_transferts.pl
> 
> This file does not exist in master. Remove it before applying the patch.

Oups. OK, sorry for that
Comment 18 Koha Team Lyon 3 2014-03-11 10:51:26 UTC
The sandbox you've requested is not ready.
Some problems occurred applying patches from bug 10860:
<h1>Something went wrong !</h1>Applying: Bug 10860: In-House Use
Using index info to reconstruct a base tree...
<stdin>:1171: new blank line at EOF.
+
warning: 1 line adds whitespace errors.
Falling back to patching base and 3-way merge...
Auto-merging C4/Circulation.pm
Auto-merging C4/Items.pm
Auto-merging circ/circulation.pl
CONFLICT (content): Merge conflict in circ/circulation.pl
Auto-merging installer/data/mysql/kohastructure.sql
Auto-merging installer/data/mysql/sysprefs.sql
Auto-merging installer/data/mysql/updatedatabase.pl
CONFLICT (content): Merge conflict in installer/data/mysql/updatedatabase.pl
Auto-merging koha-tmpl/intranet-tmpl/prog/en/css/staff-global.css
CONFLICT (content): Merge conflict in koha-tmpl/intranet-tmpl/prog/en/css/staff-global.css
Auto-merging koha-tmpl/intranet-tmpl/prog/en/js/datatables.js
Auto-merging koha-tmpl/intranet-tmpl/prog/en/js/pages/circulation.js
Auto-merging koha-tmpl/intranet-tmpl/prog/en/modules/admin/preferences/circulation.pref
Auto-merging koha-tmpl/intranet-tmpl/prog/en/modules/catalogue/detail.tt
Auto-merging koha-tmpl/intranet-tmpl/prog/en/modules/circ/circulation.tt
Auto-merging koha-tmpl/intranet-tmpl/prog/en/modules/members/readingrec.tt
CONFLICT (content): Merge conflict in koha-tmpl/intranet-tmpl/prog/en/modules/members/readingrec.tt
Auto-merging koha-tmpl/opac-tmpl/prog/en/includes/item-status.inc
CONFLICT (content): Merge conflict in koha-tmpl/opac-tmpl/prog/en/includes/item-status.inc
Failed to merge in the changes.
Patch failed at 0001 Bug 10860: In-House Use
When you have resolved this problem run git bz apply --continue.
If you would prefer to skip this patch, instead run git bz apply --skip.
To restore the original branch and stop patching run git bz apply --abort.
Bug 10860 - In-House Use

22461 - Bug 10860: In-House Use

Apply? [(y)es, (n)o, (i)nteractive] Patch left in /tmp/Bug-10860-In-House-Use-_cegfo.patch .
Comment 19 Jonathan Druart 2014-03-11 11:31:50 UTC Comment hidden (obsolete)
Comment 20 Jonathan Druart 2014-03-11 14:44:58 UTC Comment hidden (obsolete)
Comment 21 Jonathan Druart 2014-03-11 16:03:36 UTC Comment hidden (obsolete)
Comment 22 Koha Team Lyon 3 2014-03-12 09:32:01 UTC
I'm not sure to see the purpose of this patch but I test it anyway.
There's 2 problems for the moment:
1. You can renew the "in house-use' for a normal duration checkout
2. There's an error on readingrec.pl
Software error:
Template process failed: file error - parse error - /home/koha/src/koha-tmpl/intranet-tmpl/prog/en/modules/members/readingrec.tt line 137: unexpected token (ELSE)
  [% ELSE %] at /home/koha/src/C4/Templates.pm line 132.
Comment 23 Jonathan Druart 2014-03-12 14:54:10 UTC Comment hidden (obsolete)
Comment 24 Jonathan Druart 2014-03-12 15:28:37 UTC Comment hidden (obsolete)
Comment 25 Jonathan Druart 2014-03-12 15:28:43 UTC Comment hidden (obsolete)
Comment 26 David Cook 2014-03-26 04:50:29 UTC
This feature seems a bit bizarre to me.

In my experience, library staff periodically gather up materials lying around, and check them in as an "in-house use" before re-shelving. This is useful in that it shows that someone used it (at least once) even if they didn't actually check it out from the library.

However, this feature doesn't seem to be that type of "in-house use".

If I understand correctly, this would actually be a check-out to a patron? The idea being that they're not allowed to take it out of the library? That it would be due back at the desk before the library closes?
Comment 27 Jonathan Druart 2014-03-26 08:29:54 UTC
(In reply to David Cook from comment #26)
> If I understand correctly, this would actually be a check-out to a patron?
> The idea being that they're not allowed to take it out of the library? That
> it would be due back at the desk before the library closes?

Yes, exactly.
Comment 28 Katrin Fischer 2014-03-26 08:32:56 UTC
Hm, maybe it's more like a 'reading room' use then? Not sure if that's the right term in English, but I think we have something similar here.
Comment 29 Jonathan Druart 2014-09-05 11:07:20 UTC Comment hidden (obsolete)
Comment 30 Jonathan Druart 2014-09-05 11:08:24 UTC
Patch rebased, not trivial.
Comment 31 Galen Charlton 2014-09-09 23:27:23 UTC
(In reply to Katrin Fischer from comment #28)
> Hm, maybe it's more like a 'reading room' use then? Not sure if that's the
> right term in English, but I think we have something similar here.

I've only taken the most superficial of looks at this, but if the idea is to record loans of items that never physically leave the library, and which are associated with specific patrons (i.e., are not anonymous), yes, I'd agree that "reading room" is closer to the mark in English.

(In reply to David Cook from comment #26)
> This feature seems a bit bizarre to me.
> 
> In my experience, library staff periodically gather up materials lying
> around, and check them in as an "in-house use" before re-shelving. This is
> useful in that it shows that someone used it (at least once) even if they
> didn't actually check it out from the library.

What David describes matches how US librarians would understand "in-house use"
Comment 32 Galen Charlton 2014-09-09 23:31:22 UTC
Comment on attachment 31388 [details] [review]
Bug 10860: In-House Use

Review of attachment 31388 [details] [review]:
-----------------------------------------------------------------

::: koha-tmpl/intranet-tmpl/prog/en/css/staff-global.css
@@ -2680,5 @@
> -#transport-types {
> -    padding-top: 0.5px;
> -}
> -
> -#i18nMenu .navbar-text .currentlanguage {

I don't see a good reason for this patch to be removing this rule and all of the following rules.  Issue during the last rebase?
Comment 33 David Cook 2014-09-10 04:31:54 UTC
(In reply to Jonathan Druart from comment #27)
> (In reply to David Cook from comment #26)
> > If I understand correctly, this would actually be a check-out to a patron?
> > The idea being that they're not allowed to take it out of the library? That
> > it would be due back at the desk before the library closes?
> 
> Yes, exactly.

Ahh. Yeah, I don't think "in-house use" would be the appropriate term in English. At least in North America. I'm not sure about other parts of the English-speaking world.

It's an interesting idea though. "Reading room use" is the closest I can think of for this feature. The downside of "reading room use" is that it implies media that can be read by a person. But it's not an "internal use" either. I'm not sure what the most appropriate term would be.
Comment 34 Jonathan Druart 2014-09-10 14:30:36 UTC
(In reply to Galen Charlton from comment #31)
> (In reply to Katrin Fischer from comment #28)
> > Hm, maybe it's more like a 'reading room' use then? Not sure if that's the
> > right term in English, but I think we have something similar here.
> 
> I've only taken the most superficial of looks at this, but if the idea is to
> record loans of items that never physically leave the library, and which are
> associated with specific patrons (i.e., are not anonymous), yes, I'd agree
> that "reading room" is closer to the mark in English.

Thanks Galen for your suggestion.
During the first meeting, guys told me that 'on-site' was better than 'in-house use'.
So what is the best between "reading room" and "on-site"? :)
Maybe there is no generic term in English?
Should I sent a request on the mailing list?
Comment 35 Jonathan Druart 2014-09-10 14:31:04 UTC
(In reply to Galen Charlton from comment #32)
> I don't see a good reason for this patch to be removing this rule and all of
> the following rules.  Issue during the last rebase?

Yes, absolutely! Will fix it.
Comment 36 Jonathan Druart 2014-09-10 14:36:17 UTC Comment hidden (obsolete)
Comment 37 David Cook 2014-09-10 23:17:37 UTC
(In reply to Jonathan Druart from comment #34)
> (In reply to Galen Charlton from comment #31)
> > (In reply to Katrin Fischer from comment #28)
> > > Hm, maybe it's more like a 'reading room' use then? Not sure if that's the
> > > right term in English, but I think we have something similar here.
> > 
> > I've only taken the most superficial of looks at this, but if the idea is to
> > record loans of items that never physically leave the library, and which are
> > associated with specific patrons (i.e., are not anonymous), yes, I'd agree
> > that "reading room" is closer to the mark in English.
> 
> Thanks Galen for your suggestion.
> During the first meeting, guys told me that 'on-site' was better than
> 'in-house use'.
> So what is the best between "reading room" and "on-site"? :)
> Maybe there is no generic term in English?
> Should I sent a request on the mailing list?

"On-site" actually sounds pretty good to me. I suppose I still wonder about people getting confused with "in-house" though :/. Maybe "On-site loan" or "On-site check out" to be a bit more explicit about what is happening? 

The mailing list is probably a good idea for this one.
Comment 38 Jonathan Druart 2014-09-11 08:16:23 UTC
(In reply to David Cook from comment #37)
> The mailing list is probably a good idea for this one.

Mail sent on the koha ML.
Comment 39 Indranil Das Gupta 2014-09-11 08:33:38 UTC
(In reply to Jonathan Druart from comment #38)
> (In reply to David Cook from comment #37)
> > The mailing list is probably a good idea for this one.
> 
> Mail sent on the koha ML.

how about "in-library" or "intra-library" use? keeps it 'in the library' but doesn't necessary restrict it to a specific area with-in the library?
Comment 40 Katrin Fischer 2014-09-11 12:13:42 UTC
Hi Jonathan, reading through the description - can you explain some more about the use case for the cronjob and how it might be used in the library? Thx!
Comment 41 Jonathan Druart 2014-09-11 14:15:22 UTC
(In reply to Katrin Fischer from comment #40)
> Hi Jonathan, reading through the description - can you explain some more
> about the use case for the cronjob and how it might be used in the library?

The script was for a specific need: The patrons cannot checkout specific items (rares for instance). But they can checkout them for an "in-house use" (replace this term with the one you prefer :)).
These items are stored in a special local (location).
At the end of the day, the items which have been checked out "in-house" are marked in transit. But actually someone puts them back in the local, so they are not in transit anymore. To avoid a manual action, this script simulates a checkin. That's why you can specify a location in parameter of the script.

I did not remember the script was submitted here. I can remove it if someone notes it's too specific.
Comment 42 Katrin Fischer 2014-09-11 14:18:20 UTC
The script sounds interesting, but maybe split it off to a separate bug?
Comment 43 Jonathan Druart 2014-09-11 14:33:12 UTC
(In reply to Katrin Fischer from comment #42)
> The script sounds interesting, but maybe split it off to a separate bug?

I am not sure it could be useful in another context.
Comment 44 Katrin Fischer 2014-09-11 18:50:06 UTC
I think I'd leave the script out for now and maybe add it later on.
Comment 45 Jonathan Druart 2014-09-12 07:47:33 UTC Comment hidden (obsolete)
Comment 46 Jonathan Druart 2014-09-12 07:48:30 UTC
(In reply to Katrin Fischer from comment #44)
> I think I'd leave the script out for now and maybe add it later on.

I removed it, but it is part of the feature, I don't really understand why I have to split it.
Comment 47 Katrin Fischer 2014-09-12 08:09:01 UTC
Hi Jonathan,

without the cronjob the patch is fully testable on a sandbox I think, so putting it on a separate bug depending on this one could speed up things here a bit. :)

Also I got a few questions about the script already - I thought it would be nicer to have them on a separate thread, as they are specific to the script (automating check-ins and possible complications) and would probably not be any problem for testing the main part of the feature.
Comment 48 Jonathan Druart 2014-09-16 16:14:34 UTC
A massive sed should replace "in-house use" with "on-site checkouts".
The community agreed on this new term (dev meeting September 16, 2014).

Back to "assigned".
Comment 49 Jonathan Druart 2014-09-17 09:56:58 UTC Comment hidden (obsolete)
Comment 50 Jonathan Druart 2014-09-17 09:57:06 UTC Comment hidden (obsolete)
Comment 51 Chris Cormack 2014-10-10 20:29:57 UTC
I tried to test this, but with the patch, the previous checkouts never load, it just says processing. It may be an error I made fixing the conflicts, could you have a look please Jonathan.
Apart from that, all the other functionality seems to work fine
Comment 52 Jonathan Druart 2014-10-10 21:03:07 UTC Comment hidden (obsolete)
Comment 53 Jonathan Druart 2014-10-10 21:04:02 UTC Comment hidden (obsolete)
Comment 54 Chris Cormack 2014-10-10 21:37:33 UTC Comment hidden (obsolete)
Comment 55 Chris Cormack 2014-10-10 21:39:10 UTC Comment hidden (obsolete)
Comment 56 Kyle M Hall 2014-10-17 17:42:33 UTC
I'm getting failed unit tests:
prove -v t/db_dependent/Circulation.t
t/db_dependent/Circulation.t ..
1..55
ok 1 - use C4::Circulation;
ok 2 - CircControl changed to PickupLibrary
ok 3 - _GetCircControlBranch returned item branch (no userenv defined)
ok 4 - CircControl changed to PatronLibrary
ok 5 - _GetCircControlBranch returned borrower branch
ok 6 - CircControl changed to ItemHomeLibrary
ok 7 - _GetCircControlBranch returned item branch
ok 8 - userenv set
ok 9 - CircControl changed to PickupLibrary
ok 10 - _GetCircControlBranch returned current branch
ok 11 - CircControl changed to PatronLibrary
ok 12 - _GetCircControlBranch returned borrower branch
ok 13 - CircControl changed to ItemHomeLibrary
ok 14 - _GetCircControlBranch returned item branch
ok 15 - CircControl reset to its initial value
ok 16 - ProcessOfflinePayment makes payment correctly
ok 17 - Item 1 checked out, due date: 2014-11-03T23:59:00
ok 18 - Item 2 checked out, due date: 2014-11-03T23:59:00
ok 19 - Item checked out to John Renewal
ok 20 - Can renew, no holds for this title or item
ok 21 - (Bug 10663) Cannot renew, reserved
ok 22 - (Bug 10663) Cannot renew, reserved (returned error is on_reserve)
ok 23 - (Bug 10663) Cannot renew, reserved
ok 24 - (Bug 10663) Cannot renew, reserved (returned error is on_reserve)
ok 25 - hold marked completed when checking out item that fills it
ok 26 - (Bug 10663) Cannot renew, item reserved
ok 27 - (Bug 10663) Cannot renew, item reserved (returned error is on_reserve)
ok 28 - Can renew item 2, item-level hold is on item 1
ok 29 - Can renew, item is marked not for loan, hold does not block
Can't use string ("1") as a HASH ref while "strict refs" in use at C4/Circulation.pm line 1187.
# Looks like you planned 55 tests but ran 29.
# Looks like your test exited with 255 just after 29.
Dubious, test returned 255 (wstat 65280, 0xff00)
Failed 26/55 subtests

Test Summary Report
-------------------
t/db_dependent/Circulation.t (Wstat: 65280 Tests: 29 Failed: 0)
  Non-zero exit status: 255
  Parse errors: Bad plan.  You planned 55 tests but ran 29.
Files=1, Tests=29,  3 wallclock secs ( 0.01 usr  0.01 sys +  1.12 cusr  0.05 csys =  1.19 CPU)
Result: FAIL
Comment 57 Kyle M Hall 2014-10-22 15:17:27 UTC Comment hidden (obsolete)
Comment 58 Kyle M Hall 2014-10-22 15:17:35 UTC Comment hidden (obsolete)
Comment 59 Kyle M Hall 2014-10-22 15:17:38 UTC Comment hidden (obsolete)
Comment 60 Katrin Fischer 2014-10-26 21:50:11 UTC
Working on this next.
Comment 61 Katrin Fischer 2014-10-28 07:47:53 UTC
Still working on this, will post comments tonight.
Comment 62 Katrin Fischer 2014-10-29 23:51:53 UTC Comment hidden (obsolete)
Comment 63 Katrin Fischer 2014-10-29 23:56:36 UTC
I really like this feature and would like to see it in Koha, but there are 2 problems I think we need to fix before:

- Patches change the OPAC prog templates which will be removed in a few moments and miss any changes to the Bootstrap OPAC
- We shoudn't start yet another naming convention for system preferences. Please choose a system preference without spaces (I personally prefer camel case).

Some notes:

1) Checkouts
- Normal and on-site checkouts work ok, no regressions found
- I think some libraries might want to set the date/time individually,
  but this could be added later as an option

2) Reading history
- Filtering and sorting works ok
- Provided a follow up to make the table display as before, when
  On-site checkouts are disabled.
Comment 64 Kyle M Hall 2014-10-30 15:58:37 UTC Comment hidden (obsolete)
Comment 65 Kyle M Hall 2014-10-30 16:02:54 UTC Comment hidden (obsolete)
Comment 66 Kyle M Hall 2014-10-30 16:03:03 UTC Comment hidden (obsolete)
Comment 67 Kyle M Hall 2014-10-30 16:03:06 UTC Comment hidden (obsolete)
Comment 68 Kyle M Hall 2014-10-30 16:03:09 UTC Comment hidden (obsolete)
Comment 69 Kyle M Hall 2014-10-30 16:03:12 UTC Comment hidden (obsolete)
Comment 70 Katrin Fischer 2014-10-30 19:37:41 UTC Comment hidden (obsolete)
Comment 71 Katrin Fischer 2014-10-30 19:37:55 UTC Comment hidden (obsolete)
Comment 72 Kyle M Hall 2014-10-31 10:22:23 UTC Comment hidden (obsolete)
Comment 73 Kyle M Hall 2014-10-31 10:22:48 UTC Comment hidden (obsolete)
Comment 74 Kyle M Hall 2014-10-31 10:22:52 UTC Comment hidden (obsolete)
Comment 75 Kyle M Hall 2014-10-31 10:22:55 UTC Comment hidden (obsolete)
Comment 76 Kyle M Hall 2014-10-31 10:22:58 UTC Comment hidden (obsolete)
Comment 77 Kyle M Hall 2014-10-31 10:23:01 UTC Comment hidden (obsolete)
Comment 78 Kyle M Hall 2014-10-31 10:23:05 UTC Comment hidden (obsolete)
Comment 79 Katrin Fischer 2014-10-31 19:56:59 UTC
Created attachment 33105 [details] [review]
Bug 10860: In-House Use

This patch implements the In-House Use feature for Koha.

It adds:
- 2 new sysprefs:
  'In-House Use' to enable/disable this feature
  'In-House Use Forced' to enable/disable the feature for *all* users.
- 2 new columns issues.inhouse_use and old_issues.inhouse_use
- Datatable on the circulation history pages (readingrec) at the OPAC
  and the intranet.

A new checkbox in the Circulation tab. If checked, the issue become a
in-house use (in the statistics and issues tables).
When you check it, the due date changes to the today date.

The syspref "In-House Use Force" allows to force the in-house use to
permit the checkout even if the borrower is debarred or others problems.

In the issue table, a new string (in red) marks the issue as "in-house use".

The circulation history contains 3 tabs : "all", "checkout" and
"in-house use" (OPAC and intranet).

The cronjob script:
If AutomaticItemReturn if off, a library would like not to do a transit
operation manually. This script (to launch each night) do returns
for a specific branches.

Test plan:
1/ Execute the updatedatabase entry
2/ Enable the 'In-House Use' pref.
3/ Checkout a biblio for a patron and check the 'in-house use' checkbox.
4/ Check that the due date is the today date (with 23:59) and is not modifiable.
5/ Click on the check out button and check that the new check out
appears in the table bellow with the "(In-house use)" string.
6/ Go on the circulation history pages (readingrec and opac-readingrec)
and try the 3 tabs. In the last one, your last checkout should appear.
7/ Check in.
8/ Check readingrec pages.
9/ Choose a debarred patron and check that you cannot checkout a biblio
for him.
10/ Switch on the 'In-House Use Forced' pref
11/ You are now allowed to checkout a biblio for the debarred patron.

Signed-off-by: Chris Cormack <chris@bigballofwax.co.nz>
Comment 80 Katrin Fischer 2014-10-31 19:57:07 UTC
Created attachment 33106 [details] [review]
Bug 10860 - Change "in-house use" to "on-site checkout"
Comment 81 Katrin Fischer 2014-10-31 19:57:12 UTC
Created attachment 33107 [details] [review]
Bug 10860 [QA Followup] - Fix misc issues
Comment 82 Katrin Fischer 2014-10-31 19:57:16 UTC
Created attachment 33108 [details] [review]
Bug 10860: Follow-up - staff reading record

- capitalization fix "Checked out"
- display new tabs only when feature is activated
- fixes a qa script complaint about POD in Items.pm

Signed-off-by: Kyle M Hall <kyle@bywatersolutions.com>
Comment 83 Katrin Fischer 2014-10-31 19:57:21 UTC
Created attachment 33109 [details] [review]
Bug 10860 [QA Followup] - Rename system preferences

Signed-off-by: Katrin Fischer <katrin.fischer.83@web.de>
Comment 84 Katrin Fischer 2014-10-31 19:57:26 UTC
Created attachment 33110 [details] [review]
Bug 10860: Follow-up - fix some template variable issues

Fixing some simple display issues caused by missing/misnamed
variables, probably consequence of the renaming before.

Amended test plan:
- Make sure that if OnSiteCheckoutsForce is set, you can
  still perform onsite checkouts and only those.
- Check the detail page in staff says *currently in local use by*
  for an on-site checked out item
- Check the detail page in OPAC with OPACShowCheckoutName active
  for the same.

Signed-off-by: Kyle M Hall <kyle@bywatersolutions.com>
Comment 85 Katrin Fischer 2014-10-31 19:57:31 UTC
Created attachment 33111 [details] [review]
[PASSED QA] Bug 10860 [QA Followup] - Use Koha.Preference

Signed-off-by: Katrin Fischer <Katrin.Fischer.83@web.de>
Comment 86 Tomás Cohen Arazi 2014-11-03 14:37:05 UTC
Created attachment 33163 [details] [review]
Bug 10860: Update DBIx

Signed-off-by: Tomas Cohen Arazi <tomascohen@gmail.com>
Comment 87 Tomás Cohen Arazi 2014-11-03 14:55:05 UTC
Created attachment 33165 [details] [review]
Bug 10860: (RM followup) checkout-related sysprefs belong to the checkouts section

Signed-off-by: Tomas Cohen Arazi <tomascohen@gmail.com>
Comment 88 Tomás Cohen Arazi 2014-11-03 15:31:23 UTC
Patches pushed to master.

Thanks everyone!
Comment 89 Mason James 2015-01-20 14:47:10 UTC
Skipping patch for 3.16.x series